#include <arpa/inet.h>
#include <assert.h>
#include <errno.h>
#include <error.h>
#include <fcntl.h>
#include <getopt.h>
#include <immintrin.h>
#include <inttypes.h>
#include <limits.h>
#include <linux/if_packet.h>
#include <math.h>
#include <netdb.h>
#include <netinet/ether.h>
#include <netinet/in.h>
#include <net/if.h>
#include <pthread.h>
#include <sched.h>
#include <semaphore.h>
#include <signal.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include "../eNB-simulator/trx-ecpri/utils.c"

#define AVX2

typedef struct {
  float re;
  float im;
} Complex;

#include "../eNB-simulator/trx-ecpri/private/bf1_avx2.c"

#define N_CHANNELS 4
#define N_SAMPLES 32
#define BASIC_FRAME_FREQ 3840000

char in[256];
char out[256];
char out2[256];

int main(int argc, char ** argv) {

  int compress;
  int16_t int16_samples[64];
  const float mult = 1. / 32767.;

  if(argc != 2)
    fprintf(stderr, "Wrong argument number");

  compress = (argv[1][0] == 'c');

  freopen(NULL, "rb", stdin);
  fread(in, compress ? (64 * 4) : 60 , 1, stdin);
  fclose(stdin);

  if(compress) {
      encode_s64_b60_2((uint8_t*) out, (float *) in);
  } else {
      decode_s64_b60_2((float *) out, (uint8_t*) in);
  }

  freopen(NULL, "wb", stdout);
  fwrite(out, compress ? 60 : (64 * 4), 1, stdout);
  fclose(stdout);
  
  return 0;
}
