import subprocess
import struct
import random

def float_to_byte(float_list):
  iq_samples_bytes = bytearray(64 * 4)
  for i in range(64):
    b = struct.pack('f', float_list[i])
    for j in range(4):
      iq_samples_bytes[i * 4 + j] = b[j]
  return bytes(iq_samples_bytes)

def byte_to_float(b):
  float_list = []
  for i in range(64):
    x = struct.unpack('f', b[4 * i:4 * (i+1)])[0]
    float_list.append(x)
  return float_list

def compress(b, avx):
  s = subprocess.run(
                  ["./bf1", "c" + ("a" if avx else "s")],
                  input=b,
                  capture_output=True,
  )
  return s.stdout

def decompress(b, avx):
  s = subprocess.run(["./bf1", "d" + ("a" if avx else "s")],
                  input=b,
                  capture_output=True,
  )
  return s.stdout

iq_samples = [0.2 * (random.randint(1,1000) / 1000.0) for i in range(64)]
compressed = compress(float_to_byte(iq_samples), True)
decompressed = decompress(compressed, False)
iq_samples2 = byte_to_float(decompressed)
d = []
for i in range(64):
  d.append(abs(iq_samples[i]-iq_samples2[i]))
max_d = max(map(abs, d))
print("{}".format(max(map(abs, d)) / max(map(abs, iq_samples))))

compressed = compress(float_to_byte(iq_samples), False)
decompressed = decompress(compressed, True)
iq_samples2 = byte_to_float(decompressed)
d = []
for i in range(64):
  d.append(abs(iq_samples[i]-iq_samples2[i]))
max_d = max(map(abs, d))
print("{}".format(max(map(abs, d)) / max(map(abs, iq_samples))))

compressed = compress(float_to_byte(iq_samples), True)
decompressed = decompress(compressed, True)
iq_samples2 = byte_to_float(decompressed)
d = []
for i in range(64):
  d.append(abs(iq_samples[i]-iq_samples2[i]))
max_d = max(map(abs, d))
print("{}".format(max(map(abs, d)) / max(map(abs, iq_samples))))

compressed = compress(float_to_byte(iq_samples), False)
decompressed = decompress(compressed, False)
iq_samples2 = byte_to_float(decompressed)
d = []
for i in range(64):
  d.append(abs(iq_samples[i]-iq_samples2[i]))
max_d = max(map(abs, d))
print("{}".format(max(map(abs, d)) / max(map(abs, iq_samples))))
