#!/bin/bash

DIR=$(dirname $(realpath $0))
INSTALL_DIR="/usr/bin"

if [ "$#" -ne 2 ]; then
    echo "Usage: ./install.sh ENV_FILE LOG_DIR"; exit
fi

ENV_PATH=$(realpath $1)
LOG_DIR=$(realpath $2)

for f in $(ls -1 commands);do
  cat > $INSTALL_DIR/$f << EOF
#!/bin/bash
source $ENV_PATH &&
$DIR/commands/$f > $LOG_DIR/$f.log 2> $LOG_DIR/$f.error &
EOF
  chmod +x $INSTALL_DIR/$f;
done

echo "Add in .bash_aliases:" && echo &&
for f in $(ls -1 commands);do
  echo "alias $f='sudo $f'";
done
echo
echo "Add in /etc/sudoers:" && echo &&
for f in $(ls -1 commands);do
  echo "hfr ALL=NOPASSWD:/usr/bin/$f"
done
echo
